JUCE: MidiMessageCollector Class Reference

JUCE

Public Member Functions | List of all members
MidiMessageCollector Class Reference

Collects incoming realtime MIDI messages and turns them into blocks suitable for processing by a block-based audio callback. More...

Inheritance diagram for MidiMessageCollector:

## Public Member Functions
| MidiMessageCollector ()
| Creates a MidiMessageCollector. More...
| ~MidiMessageCollector () override
| Destructor. More...
void | reset (double sampleRate)
| Clears any messages from the queue. More...
void | addMessageToQueue (const MidiMessage &message)
| Takes an incoming real-time message and adds it to the queue. More...
void | removeNextBlockOfMessages (MidiBuffer &destBuffer, int numSamples)
| Removes all the pending messages from the queue as a buffer. More...
void | handleNoteOn (MidiKeyboardState *, int midiChannel, int midiNoteNumber, float velocity) override
void | handleNoteOff (MidiKeyboardState *, int midiChannel, int midiNoteNumber, float velocity) override
void | handleIncomingMidiMessage (MidiInput *, const MidiMessage &) override
Public Member Functions inherited from MidiKeyboardStateListener
| MidiKeyboardStateListener ()=default
virtual | ~MidiKeyboardStateListener ()=default
Public Member Functions inherited from MidiInputCallback
virtual | ~MidiInputCallback ()=default
| Destructor. More...
virtual void | handlePartialSysexMessage (MidiInput *source, const uint8 *messageData, int numBytesSoFar, double timestamp)
| Notification sent each time a packet of a multi-packet sysex message arrives. More...

## Detailed Description

Collects incoming realtime MIDI messages and turns them into blocks suitable for processing by a block-based audio callback.

The class can also be used as either a MidiKeyboardStateListener or a MidiInputCallback so it can easily use a midi input or keyboard component as its source.

See also
  MidiMessage, MidiInput

## Constructor & Destructor Documentation

## ◆ MidiMessageCollector()

MidiMessageCollector::MidiMessageCollector | ( |  | ) |

Creates a MidiMessageCollector.

## ◆ ~MidiMessageCollector()

MidiMessageCollector::~MidiMessageCollector | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ reset()

void MidiMessageCollector::reset | ( | double | sampleRate | ) |

Clears any messages from the queue.

You need to call this method before starting to use the collector, so that it knows the correct sample rate to use.

## ◆ addMessageToQueue()

void MidiMessageCollector::addMessageToQueue | ( | const MidiMessage & | message | ) |

Takes an incoming real-time message and adds it to the queue.

The message's timestamp is taken, and it will be ready for retrieval as part of the block returned by the next call to removeNextBlockOfMessages().

This method is fully thread-safe when overlapping calls are made with removeNextBlockOfMessages().

## ◆ removeNextBlockOfMessages()

void MidiMessageCollector::removeNextBlockOfMessages | ( | MidiBuffer & | destBuffer,
|  | int | numSamples
| ) |  |

Removes all the pending messages from the queue as a buffer.

This will also correct the messages' timestamps to make sure they're in the range 0 to numSamples - 1.

This call should be made regularly by something like an audio processing callback, because the time that it happens is used in calculating the midi event positions.

This method is fully thread-safe when overlapping calls are made with addMessageToQueue().

Precondition: numSamples must be greater than 0.

## ◆ handleNoteOn()

void MidiMessageCollector::handleNoteOn | ( | MidiKeyboardState * | ,
|  | int | midiChannel,
|  | int | midiNoteNumber,
|  | float | velocity
| ) |  |
| overridevirtual

Implements MidiKeyboardStateListener.

## ◆ handleNoteOff()

void MidiMessageCollector::handleNoteOff | ( | MidiKeyboardState * | ,
|  | int | midiChannel,
|  | int | midiNoteNumber,
|  | float | velocity
| ) |  |
| overridevirtual

Implements MidiKeyboardStateListener.

## ◆ handleIncomingMidiMessage()

void MidiMessageCollector::handleIncomingMidiMessage | ( | MidiInput * | ,
|  | const MidiMessage & |
| ) |  |
| overridevirtual

Implements MidiInputCallback.

The documentation for this class was generated from the following file:

- juce_MidiMessageCollector.h